<?php
/*
Plugin Name: 
Plugin URI: http://1uthavi.adadaa.com/ada-a-blog-recent-posts-widget/
Description: Ada List-All-Posts-From-A-Blog:  Returns a list of most recent posts from a blog.  Based on the List-All-Posts plugin by Andrew Billits
Author: CAPitalZ
Author URI: http://adadaa.com/
Version: 0.1.2
*/

global $word_limit;
global $title_begin_wrap;
global $title_end_wrap;
global $begin_wrap;
global $end_wrap;
//global $table_prefix;
global $read_more;
global $show_author;
global $show_blog;

global $post_type;
global $blgid;
global $show_posts_id_greater_than;
global $blank_limit;
global $blank_word_limit;
global $db_prefix;
//global $avoid_title;
//$avoid_title = 'Hello World';		//if you would like to use this, then un-comment all lines that has this variable

$db_prefix = "wp_";
$show_posts_id_greater_than = 2;	//only show posts that has IDs greater than this
									//1 is Hello World and
									//2 is About page
									
$blank_limit = '10';				//Default number of titles to list, if the option was left blank
$blank_word_limit = '0';			//Default number of words in a post to display, if the option was left blank or 0 [zero]].  0 is seen as empty in php.
 
function ada_list_all_posts_from_a_blog_summary($content, $limit){
	if ( $limit == '0' ) {
	 	return '';
	 }	
	$content = explode(' ',$content);
	for($i=0; $i<$limit; $i++){
		$summary[$i] = $content[$i];
	}
	$summary = implode(' ', $summary).'..';
	return $summary;
}


function ada_echoArrayABlogPostList($arrayName) {
    global $wpdb;
	//global $table_prefix;
    global $word_limit;
    global $title_begin_wrap;
    global $title_end_wrap;
    global $begin_wrap;
    global $end_wrap;
    global $read_more;
    global $show_author;
    global $show_blog;
	
	global $db_prefix;
    
    $intArrayCount = 0;
    
    echo $begin_wrap;
    foreach ($arrayName as $arrayElement) {
        if (count($arrayElement) > 1) {
            ada_echoArrayABlogPostList($arrayElement);
        }
		else {
            $intArrayCount = $intArrayCount + 1;
			
			$info = ' - Posted ';
			
			if ($show_blog == "show"){
				$tmp_blog_name = $wpdb->get_var("SELECT option_value FROM " . $db_prefix . $arrayElement->blgid . "_options" . " WHERE option_name = 'blogname'");
				$tmp_siteurl = $wpdb->get_var("SELECT option_value FROM " . $db_prefix . $arrayElement->blgid . "_options" . " WHERE option_name = 'siteurl'");

				$info = $info . "to <a href='" . $tmp_siteurl . "'>" . $tmp_blog_name . '</a> ';
			}
			if ($show_author == "show"){
				$tmp_post_author_id = $wpdb->get_var("SELECT post_author FROM " . $db_prefix . $arrayElement->blgid . "_posts" . " WHERE ID ='" . $arrayElement->ID . "'");
				$tmp_post_author = $wpdb->get_var("SELECT display_name FROM $wpdb->users WHERE ID = '" . $tmp_post_author_id . "'");

				$info = $info .'by ' . ucfirst($tmp_post_author);
			}
			if ($show_author == 'hide' && $show_blog == 'hide'){
				$info = '';				
			}
			
			$p_title = trim($arrayElement->post_title);//v: 0.0.2
			empty($p_title)? $p_title=__("No title") : $p_title = $arrayElement->post_title;
			
			if( constant( 'VHOST' ) == 'yes' ) {
			 	//Display post title with respective permanent link
				echo $title_begin_wrap . "<a href='" . get_blog_permalink( $arrayElement->blgid, $arrayElement->ID ) . "'>" . $p_title . "</a>" . $info . $title_end_wrap;

				if ($word_limit == '') {
					echo $begin_wrap . strip_tags($arrayElement->post_content) . $end_wrap;					
				}
				else {
					if ($read_more == 'show') {
						echo $begin_wrap . strip_tags(ada_list_all_posts_from_a_blog_summary($arrayElement->post_content, $word_limit)) . " <a href='" . get_blog_permalink( $arrayElement->blgid, $arrayElement->ID ) . "' target='blank_'>(Read More)</a>" . $end_wrap;						
					}
					else {
						echo $begin_wrap . strip_tags(ada_list_all_posts_from_a_blog_summary($arrayElement->post_content, $word_limit)) . $end_wrap;
					}
				}
			}
			else {
				echo $title_begin_wrap . "<a href='" . get_blog_permalink( $arrayElement->blgid, $arrayElement->ID ) . "'>" . $p_title . "</a>" . $info . $title_end_wrap;

				if ($word_limit == '') {
					echo $begin_wrap . strip_tags($arrayElement->post_content) . $end_wrap;					
				}
				else {
					if ($read_more == 'show') {
						echo $begin_wrap . strip_tags(ada_list_all_posts_from_a_blog_from_a_blog_summary($arrayElement->post_content, $word_limit)) . " <a href='" . get_blog_permalink( $arrayElement->blgid, $arrayElement->ID ) . "' target='blank_'>(Read More)</a>" . $end_wrap;						
					}
					else {
						echo $begin_wrap . strip_tags(ada_list_all_posts_from_a_blog_summary($tmp_post_content, $word_limit)) . $end_wrap;
					}
				}
			}
		}
    }
    echo $end_wrap;
}

function ada_list_all_posts_from_a_blog($tmp_limit, $tmp_word_limit, $tmp_begin_wrap, $tmp_end_wrap, $tmp_title_begin_wrap, $tmp_title_end_wrap, $tmp_read_more,$tmp_show_author,$tmp_show_blog, $tmp_post_type, $tmp_blog_id) {
    global $wpdb;
    global $word_limit;
    global $title_begin_wrap;
    global $title_end_wrap;
    global $begin_wrap;
    global $end_wrap;
    global $read_more;
    global $show_author;
    global $show_blog;

	global $post_type;
	global $blgid;
	//to be able to use the value mentioned at the top of this file    
	global $show_posts_id_greater_than;
	global $blank_limit;
	global $blank_word_limit;
	global $db_prefix;
    
    if ($tmp_show_blog == "show") {
        $show_blog = "show";
    } else {
		$show_blog = "hide";
    }
    if ($tmp_read_more == "show") {
        $read_more = "show";
    } else {
		$read_more = "hide";
    }
	if ($tmp_show_author == "show") {
        $show_author = "show";
    } else {
		$show_author = "hide";
    }		
    if ($tmp_word_limit == "") {
        $word_limit = $blank_word_limit;	//comment this line if you want unlimited
    } else {
        $word_limit = $tmp_word_limit;
    }
    if ($tmp_limit == "") {
        $limit = "LIMIT " . $blank_limit;	//comment this line if you want unlimited
    } else {
        $limit = "LIMIT " . $tmp_limit;
    }
    if (tmp_begin_wrap == "" || tmp_end_wrap == "" ) {
        $begin_wrap = "<p>";
        $end_wrap = "</p>";
    } else {
        $begin_wrap = $tmp_begin_wrap;
        $end_wrap = $tmp_end_wrap;
    }
    if (tmp_title_begin_wrap == "" || tmp_title_end_wrap == "" ) {
        $title_begin_wrap = "<p>";
        $title_end_wrap = "</p>";
    } else {
        $title_begin_wrap = $tmp_title_begin_wrap;
        $title_end_wrap = $tmp_title_end_wrap;
    }
    if ($tmp_order == "") {
        $order = "ORDER BY  last_updated DESC";
    } else {
        if ($tmp_order == "updated") {
            $order = "ORDER BY  last_updated DESC";
        }
        if ($tmp_order == "first_created") {
            $order = "ORDER BY  blog_id ASC";
        }
        if ($tmp_order == "last_created") {
            $order = "ORDER BY  blog_id DESC";
        }
    }
    if ($tmp_post_type =="post"){
		$post_type = "post";
	} else {
		$post_type = "page";
	}
	if ($tmp_blog_id == ""){
		$blgid = "1";
	} else {
		$blgid = $tmp_blog_id;
	}

    $post_sql = "";   

		//this sql avoids a specific post title and gets only posts posted within a day
	    //$post_sql .= " ( SELECT ID , post_content, post_title, guid, post_author, post_date_gmt , " . $blgid . " AS blgid FROM " . $db_prefix . $blgid . "_posts WHERE post_type = '".$post_type."' AND post_status = 'publish' AND post_date >= DATE_SUB(CURRENT_DATE(), INTERVAL 1 DAY) AND post_title <> '" . $avoid_title . "' ) UNION ";

	   	//this sql avoids a specific post IDs and gets only posts posted within a day
	    //$post_sql .= " ( SELECT ID , post_content, post_title, guid, post_author, post_date_gmt , " . $blgid . " AS blgid FROM " . $db_prefix . $blgid . "_posts WHERE post_type = '".$post_type."' AND post_status = 'publish' AND post_date >= DATE_SUB(CURRENT_DATE(), INTERVAL 1 DAY) AND ID > 2 ) UNION ";

		//this sql avoids a specific post IDs and gets only recent $limit posts
		//v: 0.0.2 added post_password=''
	    $post_sql .= " ( SELECT ID , post_content, post_title, guid, post_author, post_date_gmt , " . $blgid . " AS blgid FROM " . $db_prefix . $blgid . "_posts WHERE post_type = '". $post_type ."' AND post_status = 'publish' AND post_password = '' AND ID > ". $show_posts_id_greater_than . " ORDER BY post_date_gmt DESC " . $limit . " )";
	
	//execute the query
    $post_list = $wpdb->get_results($post_sql);

    $check_blogs = $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->blogs . "");
    if ($check_blogs == 0 || $check_blogs == 1 ){ // we don't want to display the admin blog so we return this even if there is one blog
        echo "<p>This are currently no active blogs</p>";
    } else {
     	//Return the list of recent posts to the calling function
		return $post_list;
    }
}
?>